uniform vec4 uLColor;
uniform vec3 uLightPos;

uniform vec3 uAmbColor;
uniform vec3 uSpecColor;
uniform vec3 uDiffColor;
uniform float uShine;

uniform sampler2D uTexLocation;

varying vec4 vColor;
varying vec4 vShade;

varying vec4 vViewPos;
varying vec4 vSpotPos;
varying vec3 vLightPos;
varying vec4 vWorldPos;

vec3 calculateS(vec4 vPosition) {
   vec3 v = -vPosition.xyz;

   vec3 reflect = -vLightPos + (2.0 * clamp(dot(normalize(vLightPos -
          vWorldPos.xyz), normalize(vShade.xyz)), 0.0, 1.0) * normalize(vShade.xyz));
   return (uSpecColor * pow(clamp(dot(normalize(vWorldPos.xyz),
          normalize(reflect)), 0.0, 1.0), uShine) * uLColor.rgb);
}

void main() {
  /* First model transforms */
  vec4 vPosition = vViewPos;
  vec4 endColor = vColor;

    vec3 endDColor = uLColor.rgb * clamp(dot(normalize(vShade.xyz),
          normalize(vLightPos - vWorldPos.xyz)), 0.0, 1.0) * uDiffColor;
    vec3 endSColor = calculateS(vPosition);
    vec3 endAColor = uAmbColor * uLColor.rgb;
    endColor = vec4(endDColor + endSColor + endAColor, 1.0);

    gl_FragColor = texture2D(uTexLocation, gl_TexCoord[0].st) * endColor;
    //gl_FragColor = vec4(gl_TexCoord[0].st, 0.0, 1.0);
}