attribute vec4 aPosition;
attribute vec4 aShade;
//attribute vec2 aTexCoord;

uniform mat4 uProjMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;
uniform mat4 uTpModelMatrix;
uniform mat4 uTpProjMatrix;
uniform mat4 uTpViewMatrix;

uniform vec3 uLightPos;
uniform vec4 uLColor;

uniform vec3 uAmbColor;
uniform vec3 uSpecColor;
uniform vec3 uDiffColor;
uniform float uShine;

varying vec4 vColor;
varying vec4 vShade;
varying vec4 vViewPos;
varying vec4 vSpotPos;

varying vec3 vLightPos;
varying vec4 vWorldPos;

void main() {
  vec4 vPosition;

  // First model transforms //
  vPosition = uModelMatrix * gl_Vertex;
  vWorldPos = vPosition;
  vPosition = uViewMatrix * vPosition;
  gl_Position = uProjMatrix * vPosition;

  vViewPos = vPosition;

  vec3 newNormal = normalize(gl_NormalMatrix * gl_Normal);
  vShade = normalize(uTpModelMatrix * vec4(newNormal.x, newNormal.y, newNormal.z, 1));

  vColor = vec4(gl_Normal.r, gl_Normal.g, gl_Normal.b, 1);

  vLightPos = normalize(gl_LightSource[0].position.xyz);

  gl_TexCoord[0] = gl_MultiTexCoord0;
  //vTexCoord = aTexCoord;
}