/* 
 * File:   Game.h
 * Author: alex
 *
 * Created on June 5, 2012, 2:08 PM
 */

#ifndef GAME_H
#define	GAME_H

#include "glm/glm.hpp"
#include "State.h"
#include <set>
#include "objects/Baseball.h"
#include "objects/Enemy.h"

class Game : public State
{
public:
    Game();
    Game(const Game& orig);
    virtual ~Game();

    void draw();
    void update();

    void mouseMoved(int x, int y);

    void pause();
    void resume();

    void printEnemies();
private:
    long distance;

    // bounds for enemy spawning (and deletion)
    glm::vec3 lowerBounds;
    glm::vec3 upperBounds;

    // the minimum z velocity for enemies
    float baseVelocity;
    // increases the baseVelocity each cycle
    float baseAcceleration;

    float spawnChance;
    float spawnChanceInc;

    Baseball baseball;
    std::set<Enemy*> enemies;

    bool shouldSpawn();
    Enemy* newEnemy();

    bool isPastCamera(Enemy* enemy);
    void setCursorInvisible();
};

#endif	/* GAME_H */

