/* 
 * File:   GameOver.cpp
 * Author: alex
 * 
 * Created on June 6, 2012, 4:48 PM
 */

#include "GameOver.h"
#include "FinalProject.h"
#include "GlutTextHelper.h"
#include "Game.h"

#define ROTATE_SPEED 2
#define SCALE_SPEED 0.03

GameOver::GameOver(long dist)
{
    distance = dist;

    scale = 1;
    rotation = 0;

    reverse = false;
}

GameOver::GameOver(const GameOver& orig)
{
}

GameOver::~GameOver()
{
}

void GameOver::draw()
{
    std::string distStr = "Distance: ";
    char buff[50];
    sprintf(buff, "%ld", distance);
    drawText(distStr.append(buff).append("mi"), 0.002 * scale, vec3(0, 3.6, 0.51));
    
    std::string title = "Game Over";
    drawText(title, 0.011, rotation,  vec3(0, 0.15, 0.51));

    std::string subTitle = "Click to Retry";
    drawText(subTitle, 0.006, vec3(0, -0.75, 0.51));
}

void GameOver::update()
{
    // scale logic
    if(!reverse)
    {
        scale += SCALE_SPEED;
    }
    else
    {
        scale -= SCALE_SPEED;
    }

    if(scale > 2.0 || scale < 1)
    {
        reverse = !reverse;
    }

    // rotation logic
    rotation += ROTATE_SPEED;
}

void GameOver::mouseClicked(int button, int state, int x, int y)
{
    advanceState(new Game());
}