/* 
 * File:   GlutTextHelper.cpp
 * Author: alex
 * 
 * Created on June 6, 2012, 4:22 PM
 */

#include "GlutTextHelper.h"
#include <GL/glut.h>
#include "FinalProject.h"
#include <string>
#include "glm/glm.hpp"

#define FONT GLUT_STROKE_ROMAN

void drawText(std::string text, float scale, glm::vec3 trans)
{
    drawText(text, scale, 0.0f, trans);
}

void drawText(std::string text, float scale, float rotate, glm::vec3 trans)
{
    int totalLen = 0;

    RenderingHelper ModelTrans;
    ModelTrans.useModelViewMatrix();
    ModelTrans.loadIdentity();

    setColors(0, vec3(0));
    ModelTrans.pushMatrix();

    ModelTrans.translate(trans);
    ModelTrans.rotate(rotate, vec3(0, 1, 0));
    ModelTrans.scale(scale);
    ModelTrans.translate(vec3(-1 * getTextCenter(text), 0, 0));

    for(int i = 0; i < text.length(); i++)
    {
        ModelTrans.pushMatrix();

        ModelTrans.translate(vec3(totalLen, 0, 0));
        totalLen += glutStrokeWidth(FONT, text[i]);

        SetModel(ModelTrans);
        glutStrokeCharacter(FONT, text[i]);

        ModelTrans.popMatrix();
    }

    ModelTrans.popMatrix();
}

float getTextCenter(std::string text)
{
    return glutStrokeLength(FONT, (const unsigned char*) text.c_str()) / 2.0;
}