/* 
 * File:   Baseball.cpp
 * Author: alex
 * 
 * Created on June 3, 2012, 6:23 PM
 */

#include "Baseball.h"

#include "../GLSL_helper.h"
#include "../glm/glm.hpp"
#include "../glm/gtc/matrix_transform.hpp" //perspective, trans etc
#include "../glm/gtc/type_ptr.hpp" //value_ptr
#include "../RenderingHelper.h"
#include "../FinalProject.h"

#define BASEBALL_SCALE .5
#define ROTATION_SPEED 50

Baseball::Baseball()
{
    position = vec3(0);
    
    rotation = 0.0;

    textureid = 0;
}

Baseball::Baseball(const Baseball& orig)
{
}

Baseball::~Baseball()
{
}

double Baseball::getRadius()
{
    return BASEBALL_SCALE;
}

void Baseball::setPosition(glm::vec3 newPosition)
{
    position = newPosition;
}

glm::vec3 Baseball::getPosition()
{
    return position;
}

void Baseball::drawBaseball()
{
    RenderingHelper ModelTrans;
    ModelTrans.useModelViewMatrix();
    ModelTrans.loadIdentity();

    GLUquadricObj *mySphere = gluNewQuadric();
    gluQuadricDrawStyle(mySphere, GLU_FILL);
    gluQuadricNormals(mySphere, GLU_SMOOTH);
    gluQuadricTexture(mySphere, GL_TRUE);

    glEnable(GL_TEXTURE_2D);
    glActiveTexture(GL_TEXTURE0);
    glBindTexture(GL_TEXTURE_2D, textureid);
    int texLocation = glGetUniformLocation(getShade(), "uTexLocation");
    safe_glUniform1i(texLocation, 0);

    setColors(5, vec3(0));
    ModelTrans.pushMatrix();
    ModelTrans.translate(position);

    ModelTrans.rotate(rotation, vec3(1, 0, 0));

    SetModel(ModelTrans);
    gluSphere(mySphere, BASEBALL_SCALE, 12, 12);
    ModelTrans.popMatrix();
    glDisable(GL_TEXTURE_2D);

    gluDeleteQuadric(mySphere);
}

void Baseball::updateBaseball()
{
    rotation -= ROTATION_SPEED;
}

std::ostream & operator<<(std::ostream& s, const Baseball& b)
{
    return s
            << "Position: " << b.position.x << ", " << b.position.y << ", " << b.position.z << "\n";
}