/* 
 * File:   enemyClass.h
 * Author: goofanader
 *
 * Created on May 23, 2012, 4:22 PM
 */

#ifndef ENEMYCLASS_H
#define	ENEMYCLASS_H

#include "../RenderingHelper.h"
#include "Textures.h"
#include <iostream>

#define RAND_COLOR ((rand() % 11) * .1)
#define RAND_VELOCITY ((rand() % 3) - 1)
#define RAND_SCALE std::abs(((rand() % 30) * .02) + .2)

class Enemy
{
public:
    GLuint textureid;
    
    glm::vec3 velocity;
    glm::vec3 position;
    glm::vec3 acceleration;

    glm::vec3 color;
    glm::vec3 scaleFactor;

    virtual void drawEnemy() = 0;
    virtual void updateEnemy();
    virtual double getRadius() = 0;
    virtual bool isCloud();
    virtual ~Enemy();

    friend std::ostream& operator<<(std::ostream& s, const Enemy& e);
private:

};

#endif	/* ENEMYCLASS_H */

