#include "Plane.h"

#define BLADE_SPEED 60;

Plane::Plane(glm::vec3 newPosition, glm::vec3 newVelocity, glm::vec3 newAcceleration)
{
    textureid = 1;
    position = newPosition;
    velocity = newVelocity;
    acceleration = newAcceleration;

    color = glm::vec3(RAND_COLOR, RAND_COLOR, RAND_COLOR);
    scaleFactor = glm::vec3(RAND_SCALE);
}

Plane::Plane(const Plane& orig)
{
}

Plane::~Plane()
{
}

void Plane::drawEnemy()
{
    vec3 radiusVec = vec3(0);

    RenderingHelper ModelTrans;
    ModelTrans.useModelViewMatrix();
    ModelTrans.loadIdentity();

    GLUquadricObj *mySphere = gluNewQuadric();
    gluQuadricDrawStyle(mySphere, GLU_FILL);
    gluQuadricNormals(mySphere, GL_SMOOTH);
    gluQuadricTexture(mySphere, GL_TRUE);

    GLUquadricObj *myCylinder = gluNewQuadric();
    gluQuadricDrawStyle(mySphere, GLU_FILL);
    gluQuadricNormals(mySphere, GL_SMOOTH);
    gluQuadricTexture(mySphere, GL_TRUE);

    glEnable(GL_TEXTURE_2D);
    glActiveTexture(GL_TEXTURE0);
    glBindTexture(GL_TEXTURE_2D, textureid);
    int texLocation = glGetUniformLocation(getShade(), "uTexLocation");
    safe_glUniform1i(texLocation, 0);

    setColors(1, color);
    ModelTrans.pushMatrix();
        ModelTrans.translate(position);
        ModelTrans.rotate((180.0 / 3.141592653) * glm::atan(velocity.y, velocity.x) - 180, vec3(0, 0, 1));
        ModelTrans.rotate(-90, vec3(1,0,0));
        ModelTrans.scale(scaleFactor.x, scaleFactor.y, scaleFactor.z);

        //draw body
        ModelTrans.pushMatrix();
            ModelTrans.rotate(90, vec3(0,0,1));
            ModelTrans.rotate(90, vec3(1,0,0));
            ModelTrans.scale(1,1,5);
            SetModel(ModelTrans);
            gluCylinder(myCylinder, 1, .5, 1, 12,12);
        ModelTrans.popMatrix();

        //draw front
        ModelTrans.pushMatrix();
            SetModel(ModelTrans);
            gluSphere(mySphere,1,12,12);

            //draw front's bottom "point"
            ModelTrans.translate(vec3(-.5+.2,-.7 / 2.0 + .2,0));

            //draw blades at the nose of the plane
            ModelTrans.pushMatrix();
            ModelTrans.translate(vec3(-.95,0,0));
            ModelTrans.rotate(bladeRotation, vec3(1,0,0));
            ModelTrans.scale(.05,.05,1);
            SetModel(ModelTrans);
            gluSphere(mySphere, 1,12,12);
            ModelTrans.popMatrix();

            ModelTrans.pushMatrix();
            ModelTrans.translate(vec3(-.95,0,0));
            ModelTrans.rotate(180 + bladeRotation, vec3(1,0,0));
            ModelTrans.scale(.05,.05,1);
            SetModel(ModelTrans);
            gluSphere(mySphere, 1,12,12);
            ModelTrans.popMatrix();

            ModelTrans.scale(1,.7,1);
            SetModel(ModelTrans);
            gluSphere(mySphere,1,12,12);
        ModelTrans.popMatrix();

        //draw back
        ModelTrans.pushMatrix();
            ModelTrans.translate(vec3(5,0,0));

            //up back fin
            ModelTrans.pushMatrix();
                ModelTrans.translate(vec3(0,-.1,0));
                ModelTrans.rotate(-90, vec3(1,0,0));
                ModelTrans.scale(1,.1,1);
                SetModel(ModelTrans);
                gluCylinder(myCylinder, .5,.2,2,12,12);
            ModelTrans.popMatrix();

            //left back fin
            ModelTrans.pushMatrix();
                ModelTrans.translate(vec3(0,-.1,0));
                ModelTrans.scale(1,.1,1);
                SetModel(ModelTrans);
                gluCylinder(myCylinder, .5,.2,2,12,12);
            ModelTrans.popMatrix();

            //right back fin
            ModelTrans.pushMatrix();
                ModelTrans.translate(vec3(0,-.1,0));
                ModelTrans.rotate(180, vec3(0,1,0));
                ModelTrans.scale(1,.1,1);
                SetModel(ModelTrans);
                gluCylinder(myCylinder, .5,.2,2,12,12);
            ModelTrans.popMatrix();

            //butt sphere draw-in
            SetModel(ModelTrans);
            gluSphere(mySphere,.5,12,12);
        ModelTrans.popMatrix();

        //draw wings
        ModelTrans.pushMatrix();
            ModelTrans.translate(vec3(2.5,0,0));
            ModelTrans.rotate(90, vec3(0,1,0));
            ModelTrans.scale(3,.1,1);
            SetModel(ModelTrans);
            gluSphere(mySphere, 1, 12, 12);
        ModelTrans.popMatrix();

    ModelTrans.popMatrix();
    glDisable(GL_TEXTURE_2D);

    gluDeleteQuadric(mySphere);
    gluDeleteQuadric(myCylinder);
}

void Plane::updateEnemy()
{
    Enemy::updateEnemy();

    bladeRotation += BLADE_SPEED;
}

double Plane::getRadius()
{
    return 1.5;
}